from OritatamiSimUtils import *
from SimulatorFramework import TileType, Tile


class ONodeType:
    def __init__(self, name, color, bondToTypes):
        self.name = name
        self.color = color
        self.bondToTypes = bondToTypes
        
    def __repr__(self):
        return self.name
    
    def __str__(self):
        return self.name + " (Binds to: " + str(self.bondToTypes) + ")"

    def Output(self):
        outStr = "['" + self.name + "', '" + str(self.color) + "', " + str(self.bondToTypes) + "]"
        return outStr

    def BondsToNodeType(self, name):
        if name is None:
            return False
        if not self.bondToTypes is None:
            for b in self.bondToTypes:
                if b == name:
                    return True
        return False


class ONode:

    def __init__(self, otype, coords=None, parent=None):
        self.type = otype
        self.coords = coords
        self._bonds = []
        self.parent = parent
        self.child = None

    def __str__(self):
        outStr = "ONode[coords " + str(self.coords) + ", type " + str(self.type) + "]"
        return outStr

    def __repr__(self):
        outStr = "ONode[" + str(self.coords) + "]"
        return outStr
    
    def NumBonds(self):
        return len(self._bonds)
    
    def GetNthBond(self, n):
        return self._bonds[n]

    def AddBond(self, coords):
        if coords in self._bonds:
            return -1
        self._bonds.append(coords)
        return len(self._bonds)
    
    def RemoveBond(self, coords):
        if coords not in self._bonds:
            return -1
        self._bonds.remove(coords)
        return len(self._bonds)

